<?php

include_once( "Stats.php.inc" );
include_once( "Class.php.inc" );
include_once( "Align.php.inc" );
include_once( "Level.php.inc" );
include_once( "Sex.php.inc" );
include_once( "Name.php.inc" );
include_once( "Age.php.inc" );
include_once( "HeightWeight.php.inc" );
include_once( "Qualities.php.inc" );
include_once( "Background.php.inc" );
include_once( "Languages.php.inc" );
include_once( "Saves.php.inc" );
include_once( "SpecialAbilities.php.inc" );
include_once( "SecondarySkill.php.inc" );
include_once( "SpellsKnown.php.inc" );
include_once( "CombatTable.php.inc" );
include_once( "StartingMoney.php.inc" );
include_once( "StartingEquipment.php.inc" );

class Character
{
	//Stats
	var $str = 0;
	var $dex = 0;
	var $con = 0;
	var $int = 0;
	var $wis = 0;
	var $cha = 0;
	
	//Character Features   
	var $name = "";
	var $title = "";
	var $sex = "";
	var $class = "";
	var $align = "";
	var $level = 0;
	var $earnedxp = 0;
	var $xptolevel = 0;
	var $hitdie = 0;
	var $hpbonus = 0;
	var $hitpoints = 0;
	var $armorclass = 9;
	var $spokenlangs = array();
	var $height = 0;
	var $weight = 0;
	var $age = 0;
	var $characteristics = array();
	var $background = "";
	
	//Money
	var $goldpieces = array();
	
	//Equipment   
	var $equipment = array( 'misc'=>array(), 'food'=>array(), 'thief'=>array(), 'magic-user'=>array(), 'cleric'=>array() );
	var $magic = array();
	
	//Special Abilities
	var $spellcasting = array();
	var $spellsknown = array();
	var $spellsmemorized = array();
	var $turnundead = array();
	var $thiefskills = array();
	var $misc = "";
	
	//Attack Chart  
	var $attacktable = array();
	
	//Saves
	var $breathattack = 0;
	var $poisondeath = 0;
	var $petrifyparalyze = 0;
	var $wands = 0;
	var $spells = 0;
	
	//Strength Adj
	var $tohitbonus = 0;
	var $todambonus = 0;
	var $opendoorsbonus = 0;
	
	//Dex Adj   
	var $acmod = 0;
	var $missileatt = 0;
	var $initadd = 0;
	
	//Con Adj   
	var $hpmod = 0;
	
	//Int Adj   
	var $addlang = 0;
	var $langprof = 0;
	
	//Wis Adj   
	var $savemod = 0;
	
	//Cha Adj   
	var $reactadj = 0;
	var $retainers = 0;
	var $retainermorale = 0;
	
	function __construct( $statsMethod, $className, $alignName, $levelVal, $sexVal, $nameVal )
	{
		switch( $statsMethod )
		{
			case '3D6':
				Stats3D6( $this );
				break;
			case '4D6':
				Stats4D6( $this );
				break;
			case '5D6':
				Stats5D6( $this );
				break;
			case 'User':
				$userstat = array();
				foreach($_GET['userstat'] as $s){
					if(($s <= 18)&&($s >= 3))
						array_push($userstat, $s);
					else
						array_push($userstat, roll3D6());
				}
				Stats( $this, $userstat);
				break;
			default:
				Stats3D6( $this );
				break;
		}
		
		/* 
		This is pretty much the order that things must be called to create a character properly
		I'm thinking of implementing a function that handles all this, but I like a bit of
		"upfront control" to see what's going on.
		*/
		
		SetSex( $this, $sexVal );
		SetClass( $this, $className );
		SetAlign( $this, $alignName );
		SetLevel( $this, $levelVal );
		SetName( $this, $nameVal );
		
		SetAge( $this );
		SetHeightWeight( $this );
		GetQualities( $this );
		GenerateBackground( $this );
		SetLanguages( $this );
		SetSaves( $this );
		SetSpecialAbilities( $this );
		SecondarySkill( $this );
		GetSpellsKnown( $this );
		GetCombatTable( $this );
		StartingMoney( $this );
		StartingEquipment( $this );
	}
}

?>
