<?php
	function SetLevel( $character, $levelVal )
	{
    	$levelsFiles = array(
    						"Thief"			=> "Levels_Thief.txt",
    						"Fighter"		=> "Levels_Fighter.txt",
    	    				"Halfling"		=> "Levels_Halfling.txt",
    	    				"Dwarf"			=> "Levels_Dwarf.txt",
    	    				"Cleric"		=> "Levels_Cleric.txt",
    	    				"Magic-User"	=> "Levels_MagicUser.txt",
    	    				"Elf"			=> "Levels_Elf.txt"
    					);
    					
    	$file = explode( "\n", trim(file_get_contents("data/".$levelsFiles[$character->class])) );
    	$levelInfo = array();
    	$maleTitle = "";
    	$femaleTitle = "";
    	foreach( $file as $line )
    	{
    		$a = explode( "|", $line );
    		$level = trim( $a[0] );
    		$exp = trim( $a[1] );
    		if( count($a) > 2 && trim($a[2]) != "" )
    		{
	    		$titles = explode( ";", trim($a[2]) );
	    		$maleTitle = trim( $titles[0] );
	    		if( count($titles) > 1 )
	    			$femaleTitle = trim( $titles[1] );
	    		else
	    			$femaleTitle = $maleTitle;
    		}
    		$levelInfo[$level] = array( 'exp'=>$exp, 'maleTitle'=>$maleTitle, 'femaleTitle'=>$femaleTitle );
    	}
    	
    	$highestLevel = 0;
    	foreach( $levelInfo as $k => $v )
    		if( $k > $highestLevel )
    			$highestLevel = $k;
    	
    	if( !isset($levelVal) || $levelVal <= 0 || $levelVal == "" )
		{
			$character->level = mt_rand( 1, $highestLevel );
		}
		else
     	{
			$character->level = basename($levelVal);
			if( $highestLevel < $character->level )
				$character->level = $highestLevel;     	    
		}
		
    	if( isset($levelInfo[$character->level]) )
    		$levelLine = $levelInfo[$character->level];
    	else
    	{
    		print( "<br/><b>Error:</b> Level not found in levels file!<br/>" );
    		die();
    	}
		
    	if( $character->sex == 'Male' )
    		$character->title = $levelLine['maleTitle'];
    	else
    		$character->title = $levelLine['femaleTitle'];
    	
    	$character->earnedxp = $levelLine['exp'];
    		
		if( $character->level >= $highestLevel )
			$character->xptolevel = 'Max Level';
		else
			$character->xptolevel = $levelInfo[($character->level)+1]['exp'] - $levelLine['exp'];
			
		$total = 0;
		for( $i=1; $i<=$character->level; $i++ )
		{
			if( $i == 1 )
			{
				$tmp = $character->hitdie + $character->hpmod;
				if( $tmp < 1.0 )
					$tmp = 1.0;
				$total += $tmp;
			}
			else
			{
				if( $i >= 10 )
				{
					$total += $character->hpbonus;
				}
				else
				{
					$tmp = $character->hitdie/2 + 0.5 + $character->hpmod;
					if( $tmp < 1.0 )
						$tmp = 1.0;
					$total += $tmp;
				}
			}
		}
		$character->hitpoints = (int)ceil($total);
	}
?>
