<?php

include_once( "PotionDescription.php.inc" );
include_once( "RandomSpells.php.inc" );

/* 

This is not a duplicate of the spellbook-picking function below, as it is used to find spells on scrolls, which
could also mean curses, etc. Requires the type of spell to be looked for ($class)

*/
   
   function MagicItems( $character ){
		$armorpercent = 0;
		$weaponpercent = 0;
		$shieldpercent = 0;
		$ringpercent = 0;
		$daggerpercent = 0;
		$bowpercent = 0;
		$boltpercent = 0;
		$potionpercent = 0;
		$scrollpercent = 0;
		$scrollofprot = false;
		
	   //Armor
	   //Shield, Plate*, Banded*, Chain*, Leather, Ring of Protection, Bracers (AC 6)

	   $armortypes = array('Shield','Plate mail','Banded mail','Chainmail','Leather','Ring of Protection','Bracers');

	   $armors = array(
		'Cleric'=>array(10,5,6,8,0,2,0),
		'Druid'=>array(0,0,0,0,8,5,0),
		'Fighter'=>array(10,6,8,10,0,0,0),
		'Paladin'=>array(10,6,8,10,0,0,0),
		'Ranger'=>array(8,5,7,15,0,0,0),
		'Magic-User'=>array(0,0,0,0,0,15,4),
		'Illusionist'=>array(0,0,0,0,0,15,4),
		'Thief'=>array(0,0,0,0,10,4,0),
		'Assassin'=>array(8,0,0,0,10,3,0),
		'Dwarf'=>array(10,6,8,10,0,0,0), //Using Fighter
		'Elf'=>array(8,5,7,15,0,0,0), //Using Ranger
		'Halfling'=>array(10,6,8,10,0,0,0)); //Using Fighter 


	   $armorcheck = $armors[$character->class];

		//For Druid/Thief/Assassin
			if($armorcheck[4] > 0){
				$pickedarmor = $armortypes[4];
				$armorpercent = $armorcheck[4];
			}
		//For Magic-User/Illusionist
			else if($armorcheck[6] > 0){
				$pickedarmor = $armortypes[6];
				$armorpercent = $armorcheck[6];
			}
		//Cleric/Fighter/Paladin/Ranger/Demi-humans
			else{
				$rand = mt_rand(1,3);
				$pickedarmor = $armortypes[$rand];
				$armorpercent = $armorcheck[$rand];

			}
		//Shield Check
			if($armorcheck[0] > 0){
				$shield = True;
				$shieldpercent = $armorcheck[0];
			}

		//Ring of Protection
			if($armorcheck[5] > 0){

				$ringofprot = True;
				$ringpercent = $armorcheck[5];
			}



	   //Scrolls
	   //Chance per level, Scroll of Protection, 1 Spell, 3 Spells (only if no other)
	   $protscrolltypes = array('Protection - Demons','Protection - Devils','Protection - Elementals','Protection - Lycanthropes','Protection - Magic','Protection - Petrification','Protection - Possession','Protection - Undead');

	   $scrolls = array(
		'Cleric'=>array(8,0,3,4),
		'Druid'=>array(7,1,3,4),
		'Fighter'=>array(6,1,0,0),
		'Paladin'=>array(4,1,0,0),
		'Ranger'=>array(5,1,0,0),
		'Magic-User'=>array(15,0,4,6),
		'Illusionist'=>array(12,0,3,4),
		'Thief'=>array(6,1,3,4),
		'Assassin'=>array(3,1,3,0),
		'Dwarf'=>array(6,1,0,0), //Fighter
		'Halfling'=>array(6,1,0,0), //Fighter
		'Elf'=>array(5,1,0,0)); //Ranger

		$scrollpercent = $scrolls[$character->class][0];
		if($scrolls[$character->class][1] > 0)
			$scrollofprot = True;
		$scrollone = $scrolls[$character->class][2];
		$scrollthree = $scrolls[$character->class][3];


	   //Weapons
	   //Dagger, Sword* (short/long/scimitar), Mace*, Battle Axe*, Spear*, Bow, 15 Bolts +2*

	   $weapontypes = array('Dagger','Sword','Mace','Battleaxe','Spear','Bow','15 Bolts +2');

	   $weapons = array(
		'Cleric'=>array(0,0,12,0,0,0,0),
		'Druid'=>array(10,7,0,0,10,0,0),
		'Fighter'=>array(10,10,0,7,8,1,10),
		'Paladin'=>array(10,10,0,10,10,0,10),
		'Ranger'=>array(10,9,0,9,8,5,10),
		'Magic-User'=>array(15,0,0,0,0,0,0),
		'Illusionist'=>array(15,0,0,0,0,0,0),
		'Thief'=>array(12,11,0,0,0,0,0),
		'Assassin'=>array(10,5,5,5,5,0,1),
		'Dwarf'=>array(10,10,0,7,8,1,10), //Fighter
		'Halfling'=>array(10,10,0,7,8,1,10), //Fighter
		'Elf'=>array(10,9,0,9,8,5,10)); //Ranger

	   $weaponcheck = $weapons[$character->class];

		//Dagger Check

			if($weaponcheck[0] > 0){
				$dagger = True;
				$daggerpercent = $weaponcheck[0];
			}

		//Bow Check

			if($weaponcheck[5] > 0){
				$bow = True;
				$bowpercent = $weaponcheck[5];
			}

	   //More in-depth checks due to greater class differences regarding weapons

		switch($character->class){
			case 'Cleric':		
				$pickedweapon = $weapontypes[2];
				$weaponpercent = $weaponcheck[2];
				break;
			case 'Druid':
				$rand = array(1,5);
				$r = $rand[mt_rand(0,1)];
				$pickedweapon = $weapontypes[$r];
				$weaponpercent = $weaponcheck[$r];
				break;
			case 'Fighter':
			case 'Paladin':
			case 'Ranger':
			case 'Dwarf':
			case 'Halfling':
			case 'Elf':
				$rand = array(1,3,4,6);
				$r = $rand[mt_rand(0,3)];
				$pickedweapon = $weapontypes[$r];
				$weaponpercent = $weaponcheck[$r];
				break;
			case 'Thief':
				$pickedweapon = $weapontypes[1];
				$weaponpercent = $weaponcheck[1];
				break;	
			case 'Assassin':
				$rand = array(1,2,3,4);
				$r = $rand[mt_rand(0,3)];
				$pickedweapon = $weapontypes[$r];
				$weaponpercent = $weaponcheck[$r];
				$bolts = True;
				$boltpercent = $weaponcheck[6];
				break;
		}

	   //Potions
	   //Chance, Max Number

	   $potiontypes = array('Climbing', 'Diminution', 'Extra-healing', 'Fire Resistance', 'Flying', 'Gaseous Form', 'Growth', 'Healing', 'Invisibility', 'Polymorph Self');

	   $potions = array(
		'Cleric'=>array(6,1),
		'Druid'=>array(11,2),
		'Fighter'=>array(8,1),
		'Paladin'=>array(6,1),
		'Ranger'=>array(7,1),
		'Magic-User'=>array(10,3),
		'Illusionist'=>array(10,2),
		'Thief'=>array(9,2),
		'Assassin'=>array(5,1),
		'Dwarf'=>array(8,1), //Fighter
		'Halfling'=>array(8,1), //Fighter
		'Elf'=>array(7,1)); //Ranger

	   $potionpercent = $potions[$character->class][0];
	   $potionnumber = $potions[$character->class][1];

	   $totalpercents = array($armorpercent*$character->level,$weaponpercent*$character->level,$shieldpercent*$character->level,$ringpercent*$character->level,$daggerpercent*$character->level,$bowpercent*$character->level,$boltpercent*$character->level,$potionpercent*$character->level,$scrollpercent*$character->level);

	   //Armor, Weapon, Shield, Ring, Dagger, Bow, Bolt, Potions, Scrolls
	   $finalplusses = array(0,0,0,0,0,0,0,0,0);

	   //Initial checks; scrolls must be checked again later

		for($i=0;$i<count($finalplusses);$i++){

			//Automatically get a + for each multiple of 100%

			while($totalpercents[$i] >= 100){
				$finalplusses[$i]++;
				$totalpercents[$i] = ($totalpercents[$i] - 90) + $character->level;
			}

			//Bolts have a flat chance, so +1 or above means you have them

			if($totalpercents[$i] > 0){
				if(mt_rand(1,100) < $totalpercents[$i])
					$finalplusses[$i]++;
			}

			//No higher than +5
			if($finalplusses[$i] > 5)
				$finalplusses[$i] = 5;

		}

	   if($finalplusses[0] > 0){
			$character->magic['Armor']= $pickedarmor;
			$character->magic['ArmorPlus'] = $finalplusses[0];
	   }
	   if($finalplusses[1] > 0){
	   		if($pickedweapon == '15 Bolts +2')
				$character->magic['Bolts']= $pickedweapon;
			else{
				$character->magic['Weapon'] = $pickedweapon;
	   			$character->magic['WeaponPlus']= $finalplusses[1];	
	   		}
	   	if( isset($character->magic['Weapon']) && $character->magic['Weapon'] == 'Sword'){
		   	if($character->height < 60)
	   			$character->magic['Weapon'] = 'Shortsword';
	   		else{
	   			$rand = mt_rand(1,100);
	   			if($rand < 21)
	   				$character->magic['Weapon'] = 'Shortsword';
	   			else
	   				$character->magic['Weapon'] = 'Longsword';
	   		}
	   	}
	   
	   }
	   if(($finalplusses[2] > 0) && ($shield == True)){	
			$character->magic['Shield']= 'Shield';
	   		$character->magic['ShieldPlus'] = $finalplusses[2];
	   }
	   if(($finalplusses[3] > 0) && ($ringofprot == True)){
			$character->magic['Ring']= 'Ring of Protection +'.$finalplusses[3];
			$character->magic['RingPlus'] = $finalplusses[3];
	   }
	   if(($finalplusses[4] > 0) && ($dagger == True)){
			$character->magic['Dagger']= 'Dagger';
			$character->magic['DaggerPlus']= $finalplusses[4];
	   }
	   if(($finalplusses[5] > 0) && ($bow == True)){
			$character->magic['Bow']= 'Bow';
	   		$character->magic['BowPlus']= $finalplusses[5];
	   }
	   if(($finalplusses[6] > 0) && ($bolts == True))
			$character->magic['Bolts']= '15 Bolts +2';

	   if($finalplusses[7] > 0){
		$pots = array();
		if($finalplusses[7] > $potionnumber)
			$finalplusses[7] = $potionnumber;

		 for($i=0;$i < $finalplusses[7]; $i++){
			 $donthave = False;
			 while($donthave == False){
			       $pot = $potiontypes[mt_rand(0,count($potiontypes)-1)];
			       if(in_array($pot, $pots)){
					$donthave = False;
					   }
			       else{
				    array_push($pots, $pot.' - '.PotionDescription());
				    $donthave = True;
				   }

			 }
		}

		$character->magic['Potions'] = $pots;
	   }


	   //Scroll checking
	   $scroll = array();
	   if($scrollofprot){

		for($i=0;$i < $finalplusses[8]; $i++){
			$donthave = False;
			while($donthave == False){
				$sc = $protscrolltypes[mt_rand(0,count($protscrolltypes)-1)];
				if(in_array($sc, $scroll)){
					$donthave = False;
				 }
				 else{
					array_push($scroll, $sc);
					$donthave = True;
				}

			}
		}
		if(!empty($scroll))
			$character->magic['Scrolls'] = $scroll;

	   }

		$scrollone = $scrolls[$character->class][2];
		$scrollthree = $scrolls[$character->class][3];

	   if(empty($character->magic['Scrolls']) && $scrollone){

		$number = 0;
		$chance = $scrollone*$character->level;
		while($chance >= 100){
			$number++;
			$chance = ($chance - 90) + $character->level;
		}

		if($chance > 0){
			if(mt_rand(1,100) < $chance)
				$number++;
		}

		for($i=0;$i<$number;$i++){
			if($character->class == 'Thief'||$character->class == 'Assassin')
				$class = 'Magic-User';
			else
				$class = $character->class;
			$sp = RandomSpells($class, 1);
			foreach($sp as $s)
				array_push($scroll,$s);
		}
		if(!empty($scroll))
			$character->magic['Scrolls'] = $scroll;

	   }

	   if(empty($character->magic['Scrolls']) && $scrollthree){

		$number = 0;
		$chance = $scrollthree*$character->level;
		while($chance >= 100){
			$number++;
			$chance = ($chance - 90) + $character->level;
		}

		if($chance > 0){
			if(mt_rand(1,100) < $chance)
				$number++;
		}

		$s = "";
		for($i=0;$i<$number;$i++){
			if($character->class == 'Thief'||$character->class == 'Assassin')
				$class = 'Magic-User';
			else
				$class = $character->class;
			$sp = RandomSpells($class, 3);
			foreach($sp as $sl)
				$s .= $sl.', ';
			$s = substr($s, 0, strlen($s)-2);
			array_push($scroll,$s);
		}
		if(!empty($scroll))
			$character->magic['Scrolls'] = $scroll;
	   }
	
	
	//Assign Misc magic items...picks a level between 5 and 8, if character at or above that, he'll get an item
	//Chance to get additional items (up to 4) depending on level, sliding scale
	
   	  $miscmagictypes = array('Feather falling ring','Warmth ring','Water walking ring','Wand of negation','Wand of wonder','Bag of holding (500 pound capacity)','Boat, folding (small rowboat)','Brooch of shielding','Cloak and boots of elvenkind','Javelin of lightning, pair','Javelin of piercing, pair','Necklace of adaptation','Robe of useful items','Rope of climbing','Trident of warning','Wings of flying','Boot of levitation');
   	  if($character->level > mt_rand(4,7)){
   	  	
   	  	$miscitems = array($miscmagictypes[mt_rand(0,count($miscmagictypes)-1)]);
   	  	
   	  	if(mt_rand(1,100)<$character->level*5){
   	  		$rand = mt_rand(0,count($miscmagictypes)-1);
   	  		if(!in_array($miscmagictypes[$rand],$miscitems))
   	  			array_push($miscitems, $miscmagictypes[$rand]);
   	  	}
   	  	if(mt_rand(1,100)<$character->level*3){
		   	  $rand = mt_rand(0,count($miscmagictypes)-1);
		   	  if(!in_array($miscmagictypes[$rand],$miscitems))
		   	  	array_push($miscitems, $miscmagictypes[$rand]);
   	  	}
   	  	if(mt_rand(1,100)<$character->level){
		   	  $rand = mt_rand(0,count($miscmagictypes)-1);
		   	  if(!in_array($miscmagictypes[$rand],$miscitems))
		   	  	array_push($miscitems, $miscmagictypes[$rand]);
   	  	}
   	  	
   	        $character->magic['Misc'] = $miscitems;
   	  }
   	
   }
   
?>
