<?php

require_once('./pdf/fpdi.php');

/* 

This is for printing the PDF...FDPI imports an external PDF, FPDF to write to it. Because I'm importing
a PDF, all the text has to be positioned manually. Not very fun...

*/
   
   function PDFChar(){
   
   
     $pdf =& new FPDI();
     
     $pagecount = $pdf->setSourceFile('./pdf/sheet.pdf');
     $page1 = $pdf->importPage(1, '/MediaBox');
     $page2 = $pdf->importPage(2, '/MediaBox');
     
     $pdf->addPage();
     $pdf->useTemplate($page1);
     $pdf->SetFont('Arial','',10);
     
     if($this->sex == 'Male')
     	$s = 'M';
     else
     	$s = 'F'; 
     $pdf->Text(94,29,$this->name.' the '.$this->title.' ('.$s.')');
     $pdf->Text(161,29,$this->class);
     $pdf->Text(94,45,$this->align);
     $pdf->Text(130,45,$this->level);
     
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(112,87,$this->hitpoints);
     $pdf->Text(159,86,$this->armorclass);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,120,$this->str);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,116.5,'To Hit: '.$this->tohitbonus);
     $pdf->Text(75,118.5,'To Dam: '.$this->todambonus);
     $pdf->Text(75,121,'Open Doors: '.$this->opendoorsbonus);
          
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,135,$this->dex);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,130.5,'AC Mod: '.$this->acmod);
     $pdf->Text(75,132.5,'Initiative: '.$this->initadd);
     $pdf->Text(75,135,'Missile Adj: '.$this->missileatt);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,149,$this->con);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,149,'HP Adj: '.$this->hpmod);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,163,$this->int);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,161,'Add Langs: '.$this->addlang);
     $pdf->Text(75,164,$this->langprof);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,178,$this->wis);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,178,'Save vs. Magic: '.$this->savemod);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(32,192,$this->cha);
     $pdf->SetFont('Arial','',6);
     $pdf->Text(75,187.58,'Reaction Adj: '.$this->reactadj);
     $pdf->Text(75,189.5,'Retainers: '.$this->retainers);
     $pdf->Text(75,192,'Retainer Morale: '.$this->retainermorale);
     
     $pdf->SetFont('Arial','',12);
     $pdf->Text(112,121,$this->breathattack);
     $pdf->Text(112,138,$this->poisondeath);
     $pdf->Text(112,155,$this->petrifyparalyze);
     $pdf->Text(112,173,$this->wands);
     $pdf->Text(112,190,$this->spells);
     
     $pdf->SetFont('Arial','',10);
     $pdf->Text(65,205,$this->misc);
     
     $pdf->SetFont('Arial','',6);
     foreach($this->spokenlangs as $c){$langs .= $c.', ';}
     	 $langs = 'Languages: '.substr($langs, 0, strlen($langs)-2);
     $pdf->SetXY(27,229);
     $pdf->MultiCell(63,3,$langs,0,1,'L');
	
     $pdf->SetFont('Arial','',12);
     $pdf->SetXY(26,250);
     $atts = $this->attacktable;
     for($i=6;$i<16;$i++)
     	$pdf->Cell(9.5,3,$atts[$i],0,0,'C');
     
     if($this->thiefskills != NULL){
	$pdf->SetFont('Arial','B',5);
        $pdf->SetXY(29,215);
        $header=array('Pick Locks','Find/Remove Traps','Pick Pockets','Move Silently','Climb Walls','Hide in Shadows','Hear Noise');
	foreach($header as $h){
		$pdf->Cell(17,3,$h,1,0,'C');
	}
	$pdf->SetFont('Arial','',4);
	$pdf->SetXY(29,218);
	foreach($this->thiefskills as $ts){
		$pdf->Cell(17,3,$ts,1,0,'C');
	}
     }
     else if($this->spellcasting != NULL){
     	$pdf->SetFont('Arial','B',5);
        $pdf->SetXY(29,215);
        for($i=1;$i<=count($this->spellcasting);$i++){
		$lvl = 'Level '.$i;
		$pdf->Cell(7,3,$lvl,1,0,'C');
	}
	$pdf->SetFont('Arial','',5);
	$pdf->SetXY(29,218);
	foreach($this->spellcasting as $sc)
		$pdf->Cell(7,3,$sc,1,0,'C');
     
         $pdf->SetXY(95,207.5);
         $pdf->SetFont('Arial','',5);
         $i = 1;
         foreach($this->spellsknown as $sk){
         	sort($sk);
         	$sl = 'Lvl '.$i.': ';
         	foreach($sk as $s){
         		$sl .= $s.', ';
    		}
		$sl = substr($sl, 0, strlen($sl)-2);
    		$pdf->MultiCell(95,3.15,$sl,0,1,'L');
    		$pdf->SetX(95);
    		$i++;
    	}
    }     
     
     if($this->turnundead != NULL){
	$pdf->SetFont('Arial','B',5);
        $pdf->SetXY(29,222);
        $header=array('1HD','2HD','3HD','4HD','5HD','6HD','7HD','8HD','9HD','Spec');
	foreach($header as $h){
		$pdf->Cell(5,3,$h,1,0,'C');
	}
	$pdf->SetFont('Arial','',4);
	$pdf->SetXY(29,225);
	foreach($this->turnundead as $tu){
		$pdf->Cell(5,3,$tu,1,0,'C');
	}
     }
     $pdf->addPage();
     $pdf->useTemplate($page2);
     
    	
     //Create magic item list and print it     
       $magic = array();   
	 if(!empty($this->magic['Bow']))
                array_push($magic,'Magic Bow +'.$this->magic['BowPlus']);
         if(!empty($this->magic['Bolts']))
                array_push($magic,$this->magic['Bolts']);
         if(!empty($this->magic['Dagger']))
                array_push($magic,'Magic Dagger +'.$this->magic['DaggerPlus']);
         if(!empty($this->magic['Ring']))
                array_push($magic,'Ring of Protection +'.$this->magic['RingPlus']);
         if(!empty($this->magic['Potions'])){
                        foreach($this->magic['Potions'] as $p)
                                array_push($magic,'Potion: '.$p); 
          }
         if(!empty($this->magic['Scrolls'])){
                        foreach($this->magic['Scrolls'] as $s)
                                array_push($magic,'Scroll: '.$s);
          }
          if(!empty($this->magic['Misc'])){
                        foreach($this->magic['Misc'] as $m)
                                array_push($magic,$m);
          }
     $pdf->SetFont('Arial','',8);
     $pdf->SetXY(110,30);
     foreach($magic as $ma){
     	$pdf->Cell(40,4,$ma,0,1);
     	$pdf->SetX(110);
     }
     
     //Create equipment list then print it out
       $weapon = $this->equipment['weapon'];
       if(!empty($this->magic['WeaponPlus']))
		$weapon .= ' +'.$this->magic['WeaponPlus'];
	if($this->equipment['armor'] != 'None')
       		$armor = $this->equipment['armor'];
       if(!empty($this->magic['ArmorPlus']))
		$armor .= ' +'.$this->magic['ArmorPlus'];
	  
     $equipment = array($weapon, $armor);

     if($this->equipment['shield']){
     	if(!empty($this->magic['ShieldPlus']))
		$shieldplus = ' +'.$this->magic['ShieldPlus'];
	array_push($equipment,'Shield'.$shieldplus);
    }
    else if($this->magic['Shield']){
     	if(!empty($this->magic['ShieldPlus']))
		$shieldplus = ' +'.$this->magic['ShieldPlus'].' (not equipped)';
	array_push($equipment,'Shield'.$shieldplus);
    }
	//Just a blank line to seperate equipment from misc items
	array_push($equipment,' ');

    foreach($this->equipment['misc'] as $eq)
     	array_push($equipment,$eq);
     	
     if($this->equipment['food'] != NULL){
     		foreach($this->equipment['food'] as $eq)
     			array_push($equipment,$eq);
     	}
     if($this->equipment['magic-user'] != NULL){
     		foreach($this->equipment['magic-user'] as $eq)
     			array_push($equipment,$eq);
     	}
     	
     if($this->equipment['thief'] != NULL){
     		foreach($this->equipment['thief'] as $eq)
     			array_push($equipment,$eq);
     	}

     if($this->equipment['cleric'] != NULL){
     		foreach($this->equipment['cleric'] as $eq)
     			array_push($equipment,$eq);
     	}
     
     $pdf->SetFont('Arial','',8);
     $pdf->SetXY(25,30);
     foreach($equipment as $eq){
     	$pdf->Cell(40,4,$eq,0,1);
     	$pdf->SetX(25);
     }
     
     //Height and Weight
     
     $pdf->SetFont('Arial','',8);
     $pdf->Text(26,139,'Height: '.feettoinches($this->height));
     $pdf->Text(26,143,'Weight: '.$this->weight.'#');
     
     //Traits and background
     
     $pdf->SetFont('Arial','',8);
     $pdf->SetXY(25,144);
     foreach($this->characteristics as $key => $value){
         	$pdf->Cell(40,4,$key.': '.ucwords($value),0,1);
          	$pdf->SetX(25);
     }
     $pdf->SetX(25);
     $pdf->MultiCell(150,3,$this->background,0,1,'L');
     
     
     //Print Experience
     
     $pdf->SetFont('Arial','',10);
     $pdf->Text(37,235,$this->earnedxp);
     $pdf->Text(82,254,$this->xptolevel);
     
     //Print Money
     
     $pdf->Text(115,225,'CP: '.$this->goldpieces['CP']);
     $pdf->Text(115,232,'SP: '.$this->goldpieces['SP']);
     $pdf->Text(115,239,'EP: '.$this->goldpieces['EP']);
     $pdf->Text(115,246,'GP: '.$this->goldpieces['GP']);
     $pdf->Text(115,253,'PP: '.$this->goldpieces['PP']);
     
     $pdf->Output($this->name.'.pdf', 'D');
      
   
   }
   
?>