<?php

	include_once( "Table.php.inc" );

	function SetSpecialAbilities( $character )
	{
		$character->spellcasting = null;
		$character->turnundead = null;
		$character->thiefskills = null;
		
		$muSpellsTable = new Table( "SpcAb_MuSpells" );
		$clericSpellsTable = new Table( "SpcAb_ClericSpells" );
		$turningTable = new Table( "SpcAb_ClericTurning" );
		$thiefTable = new Table( "SpcAb_ThiefSkills" );
		
		switch($character->class)
		{
			case 'Elf':
				$character->spellcasting = $muSpellsTable->getRow( $character->level );
				$character->misc = 'Infravision 60\', Detect Hidden/Secret Doors 1-2(d6)';
				break;
			case 'Magic-User':
				$character->spellcasting = $muSpellsTable->getRow( $character->level );
				break;
			case 'Cleric':
				$character->spellcasting = $clericSpellsTable->getRow( $character->level );
				$row = $character->level;
				if( $row > $turningTable->getHighestRow() )
					$row = $turningTable->GetHighestRow();
				$character->turnundead = $turningTable->getRow( $row );
				break;
			case 'Thief':
				$character->thiefskills = $thiefTable->getRow( $character->level );
				break;
			case 'Dwarf':
				$character->misc = 'Infravision 60\', Detect traps/false walls/hidden construction/slopes 1-2(d6)';
				break;
			case 'Fighter':
				break;
			case 'Halfling':
				$character->misc = 'Hide Outdoors 90%, Hide Indoors 1-2(d6)';
				$character->missileatt++;
				break;   	
		}
	}
	
?>
