<?php

	include_once( "MagicItems.php.inc" );

   function StartingEquipment( $character ){
   	
   	MagicItems( $character );
   	
   	$armors = array('Plate mail'=>3,'Splint mail'=>4,'Banded mail'=>4,'Chainmail'=>5,'Scale mail'=>6,'Studded Leather'=>6,'Leather'=>7,'Padded'=>8,'None'=>9, 'Bracers'=>5);
	$twohanders = array('Battleaxe','Heavy pick','Polearm','Scimitar','Bastard sword','Two-handed sword','Trident','Spear','Heavy Flail');   	

    	switch($character->class){
    	
    		case 'Fighter':
    		case 'Elf':
    			$availweaps = array('Dagger','Quarterstaff','Longsword','Shortsword','Handaxe','Pick','Flail','Light hammer','Warhammer', 'Morningstar','Mace', 'Club', 'Battleaxe','Heavy pick','Polearm','Scimitar','Bastard sword','Two-handed sword','Trident','Spear','Heavy Flail');
    			$availarmor = array('Plate mail','Splint mail','Banded mail','Chainmail','Scale mail','Studded Leather','Leather','Padded');
    			$shield = True;
    			break;
    		case 'Halfling':
    		case 'Dwarf':
    			$availweaps = array('Dagger','Quarterstaff','Longsword','Shortsword','Handaxe','Pick','Flail','Light hammer','Warhammer', 'Morningstar','Mace','Club','Battleaxe');
    			$availarmor = array('Plate mail','Splint mail','Banded mail','Chainmail','Scale mail','Studded Leather','Leather','Padded');
    			$shield = True;
    			break;
    		case 'Cleric':
    			$availweaps = array('Light hammer','Warhammer','Morningstar','Mace','Club','Heavy Flail');
    			$availarmor = array('Plate mail','Splint mail','Banded mail','Chainmail','Scale mail','Studded Leather','Leather','Padded');
    			//Clerics always get holy water, 50% chance of either type of holy symbol
    			$character->equipment['cleric'] = array('Holy water');
    			$clericequip = array('Wooden Holy Symbol','Silver Holy Symbol');
    			array_push($character->equipment['cleric'],$clericequip[mt_rand(0,1)]);
    			$shield = True;
    			break;
    		case 'Magic-User':
    			$availweaps = array('Dagger', 'Quarterstaff');
    			$availarmor = array('None');
    			$character->equipment['magic-user'] = array('Spell Book');
    			$shield = False;
    			$muequip = array('Ink','Quill pen','Paper','Parchment');	
			//Magic-Users can get paper and pen
			for($i=0;$i<mt_rand(1,2);$i++){
				  $rand = mt_rand(0,count($muequip)-1);
				   	if(!in_array($muequip[$rand],$character->equipment['magic-user']))
				   		array_push($character->equipment['magic-user'],$muequip[$rand]);
			   	}
   	
    			break;
    		case 'Thief':
    			$availweaps = array('Dagger','Quarterstaff','Longsword','Shortsword','Handaxe','Pick','Flail','Light hammer','Warhammer', 'Morningstar','Mace','Club', 'Battleaxe','Heavy pick','Polearm','Scimitar','Bastard sword','Two-handed sword','Trident','Spear','Heavy Flail');
   			$availarmor = array('Leather','Padded');
   			$character->equipment['thief'] = array('Thieves\' Tools');
    			$shield = False;
    			break;
    			
    	
    	}
    	
	//Pick a random weapon

    	if( isset($availweaps) )
			$character->equipment['weapon'] = $availweaps[mt_rand(0,count($availweaps)-1)];
	
	//Set base Armor and AC here
	
	if(empty($character->magic['Armor']))
    		$character->equipment['armor'] = $availarmor[mt_rand(0,count($availarmor)-1)];
    	else
    		$character->equipment['armor'] = $character->magic['Armor'];
	
	$character->armorclass = $armors[$character->equipment['armor']] + $character->acmod;
	if( isset($character->magic['ArmorPlus']) )
		$character->armorclass -= $character->magic['ArmorPlus'];
		
    	
    	//If magic weapon, use that instead
    	
    	if(!empty($character->magic['Weapon'])){
    		$character->equipment['weapon'] = $character->magic['Weapon'];	
    	}
    	
    	
    	if( isset($character->equipment['weapon']) && in_array($character->equipment['weapon'],$twohanders))
    		$onehanded = False;
		else
			$onehanded = True;

    	//This assumes if you can use a shield, you always will with a one-handed weapon
    	
    	if($shield&&$onehanded){
    		$character->equipment['shield'] = True;
		if(!empty($character->magic['ShieldPlus']))
	    		$character->armorclass = $character->armorclass - 1 - $character->magic['ShieldPlus'];
    		else
			$character->armorclass = $character->armorclass - 1;
	}
   	
   	if(!empty($character->magic['RingPlus']))
   		$character->armorclass -= $character->magic['RingPlus'];
   	
	if($character->armorclass > 9)
   		$character->armorclass = 9;
   	
   	
   	$miscequip = array('Backpack','Bedroll','Blanket','Block and tackle','Candles','Map case','10\' Chain','Crowbar','Flask','Flint and steel','Garlic','Grappling hook','Hammer','Lantern','Lock','Manacles','Mirror','Oil','10 \' Pole','50 \' Hemp Rope','50 \' Silk Rope','Large sack','Small sack','Shovel','Iron spikes','Wooden stakes','Torches','Waterskin','Wine','Wolfsbane');
   	
   	//Up to 10 miscellaneous items
   	
   	$character->equipment['misc'] = array();
   	for($i=0;$i<mt_rand(1,10);$i++){
   		$rand = mt_rand(0,count($miscequip)-1);
   		if(!in_array($miscequip[$rand],$character->equipment['misc']))
   			array_push($character->equipment['misc'],$miscequip[$rand]);
   	}
   	
   	//Chance for food
   	$food = array('Rations','Trail rations');
   	$character->equipment['food'] = array();
   	$rand = mt_rand(1,100);
   	if($rand<20)
   		array_push($character->equipment['food'],$food[1]);
   	else if($rand < 80)
   		array_push($character->equipment['food'],$food[0]);
   		
   }

?>
