<?php

	include_once( "Dice.php.inc" );

	function Stats3D6( $character )
	{
		$character->str = d( 3, 6 );
		$character->dex = d( 3, 6 );
		$character->con = d( 3, 6 );
		$character->int = d( 3, 6 );
		$character->wis = d( 3, 6 );
		$character->cha = d( 3, 6 );
	}
	
	function Stats4D6( $character )
	{
		$character->str = d( 4, 6, 0, 3 );
		$character->dex = d( 4, 6, 0, 3 );
		$character->con = d( 4, 6, 0, 3 );
		$character->int = d( 4, 6, 0, 3 );
		$character->wis = d( 4, 6, 0, 3 );
		$character->cha = d( 4, 6, 0, 3 );
	}
	
	function Stats5D6( $character )
	{
		$character->str = d( 5, 6, 0, 3 );
		$character->dex = d( 5, 6, 0, 3 );
		$character->con = d( 5, 6, 0, 3 );
		$character->int = d( 5, 6, 0, 3 );
		$character->wis = d( 5, 6, 0, 3 );
		$character->cha = d( 5, 6, 0, 3 );
	}
	
	function Stats( $character, $stats )
	{
		$character->str = $stats[0];
		$character->dex = $stats[1];
		$character->con = $stats[2];
		$character->int = $stats[3];   	
		$character->wis = $stats[4];
		$character->cha = $stats[5];
	}
	
	function GetAdjustments( $character )
	{
		$character->tohitbonus = $character->todambonus = $character->opendoorsbonus = statMod( $character->str );

		$character->acmod = -statMod( $character->dex );
		$character->missileatt = statMod( $character->dex );
		$character->initadd = statMod( $character->dex );
		if( $character->initadd == -2 )
			$character->initadd = -1;
		else if( $character->initadd == -3 )
			$character->initadd = -2;
		else if( $character->initadd == 2 )
			$character->initadd = 1;
		else if( $character->initadd == 3 )
			$character->initadd = 2;

		$character->hpmod = statMod( $character->con );

		$character->addlang = statMod( $character->int );
		if( $character->addlang <= -3 )
			$character->langprof = "Has trouble speaking, cannot read or write";
		else if( $character->addlang == -2 )
			$character->langprof = "Cannot read or write";
		else if( $character->addlang == -1 )
			$character->langprof = "Can write simple Common words";
		else if( $character->addlang >= 0 )
			$character->langprof = "Able to read and write known languages";
		if( $character->addlang < 0 )
			$character->addlang = 0;

		$character->savemod = statMod( $character->wis );

		$val = statMod( $character->cha );
		if( $val <= -3 )
		{
			$character->reactadj = -2;
			$character->retainers = 1;
			$character->retainermorale = 4;
		}
		else if( $val == -2 )
		{
			$character->reactadj = -1;
			$character->retainers = 2;
			$character->retainermorale = 5;
		}
		else if( $val == -1 )
		{
			$character->reactadj = -1;
			$character->retainers = 3;
			$character->retainermorale = 6;
		}
		else if( $val == 0 )
		{
			$character->reactadj = 0;
			$character->retainers = 4;
			$character->retainermorale = 7;
		}
		else if( $val == 1 )
		{
			$character->reactadj = 1;
			$character->retainers = 5;
			$character->retainermorale = 8;
		}
		else if( $val == 2 )
		{
			$character->reactadj = 1;
			$character->retainers = 6;
			$character->retainermorale = 9;
		}
		else if( $val >= 3 )
		{
			$character->reactadj = 2;
			$character->retainers = 7;
			$character->retainermorale = 10;
		}
	}
	
	function statMod( $statValue )
	{
		if( $statValue <= 3 )
			return -3;
		else if( $statValue >= 4 && $statValue <= 5 )
			return -2;
		else if( $statValue >= 6 && $statValue <= 8 )
			return -1;
		else if( $statValue >= 9 && $statValue <= 12 )
			return 0;
		else if( $statValue >= 13 && $statValue <= 15 )
			return 1;
		else if( $statValue >= 16 && $statValue <= 17 )
			return 2;
		else if( $statValue >= 18 )
			return 3;
	}
	
?>