<?php

class Table
{
	private $tableColumns = null;
	private $tableRows = null;
	private $highestRow = null;
	
	function getColumns()
	{
		return $this->tableColumns;
	}
	
	function getRow( $row )
	{
    	$lowestRow = 999999999;
    	$vals = null;
    	foreach( $this->tableRows as $thisRow => $values )
    	{
    		if( $row <= $thisRow && $thisRow <= $lowestRow )
    		{
    			$lowestRow = $thisRow;
    			$vals = $values;
    		}
    	}
    	return $vals;
	}
	
	function getItem( $row, $column )
	{
		$rowData = $this->getRow( $row );
		if( $rowData == null )
			return null;
		if( !isset($rowData[$column]) )
			return null;
		return $rowData[$column];
	}
	
	function getHighestRow()
	{
		return $this->highestRow;
	}
	
	function __construct( $filename )
	{
		$filename = "data/".basename($filename).".txt";
		if( !file_exists($filename) )
		{
			print( "<br/><b>Error:</b> ".$filename." not found!<br/>" );
			die;
		}
		
    	$file = explode( "\n", trim(file_get_contents($filename)) );
    	$tableColumns = explode( "|", $file[0] );
    	for( $i=0; $i<count($tableColumns); $i++ )
    		$tableColumns[$i] = trim( $tableColumns[$i] );
    	$tableRows = array();
    	for( $i=2; $i<count($file); $i++ )
    	{
    		$vals = explode( "|", $file[$i] );
    		$a = array();
    		for( $j=0; $j<count($vals); $j++ )
    		{
    			if( $j < count($tableColumns) )
    			{
    				$a[$tableColumns[$j]] = trim( $vals[$j] );
    			}
    		}
    		$tableRows[trim($vals[0])] = $a;
    	}
    	
    	$highestRow = 0;
    	foreach( $tableRows as $k => $v )
    		if( $k > $highestRow )
    			$highestRow = $k;
		
    	$this->tableColumns = $tableColumns;
    	$this->tableRows = $tableRows;
    	$this->highestRow = $highestRow;
	}
}

?>